projects/urls.py
from django.urls import path, include

from projects import views

app_name = 'projects'
urlpatterns = [
    path('file/<int:id>', views.GetFileView.as_view(), name='get_file'),
    path('upload-file/', views.UploadFileView.as_view(), name='upload_files'),
]

sgp/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static

from sgp import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('authentication.urls')),
    path('administrator/', include('administrator.urls')),
    path('evaluator/', include('evaluator.urls')),
    path('projects/', include('projects.urls')),
    path('writer/', include('writer.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

writer/urls.py
from django.urls import path

from writer import views

app_name = 'writer'
urlpatterns = [
    path('', views.ProjectsDashboardView.as_view(), name='projects'),
    path('profile/', views.UserProfileView.as_view(), name='profile'),
    path('projects/edit/<int:id>', views.ProjectsEditView.as_view(), name='edit_project'),
    path('projects/questions/<int:id>', views.ProjectQuestionsView.as_view(), name='get_questions_project'),
    path('projects/questions-detail/<int:id>', views.ProjectDescriptionQuestionView.as_view(),
         name='get_question_detail'),
    path('projects/add/', views.AddProjectView.as_view(), name='add_project'),
    path('projects/questions/add/', views.AddQuestionsProjectView.as_view(), name='add_questions'),
]

writer/models.py
from django.db import models

# Create your models here.

writer/views.py
import json

from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.db.models import Q
from django.http import JsonResponse
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views import View

from authentication.models import UserInformation
from core.models import Category
from projects.models import Project, Question
from writer.writer_controller import WriterController


class UserProfileView(LoginRequiredMixin, View):
    template_name = "writer/profile.html"

    def get(self, request, *args, **kwargs):
        user = UserInformation.objects.get(user_id=request.user.id)
        return render(request, self.template_name, {
            'user': user,
        })

    def post(self, request, *args, **kwargs):
        try:
            user_info = UserInformation.objects.get(user=request.user)
            username = request.POST.get('username')
            first_name = request.POST.get('first_name')
            last_name = request.POST.get('last_name')
            email = request.POST.get('email')
            identification = request.POST.get('identification')
            cellphone = request.POST.get('cellphone')
            terms_conditions = request.POST.get('terms_conditions')
            biography = request.POST.get('biography')

            user_info.biography = biography
            user_info.identification = identification
            user_info.cellphone = cellphone
            user_info.save()

            user = user_info.user
            user.first_name = first_name
            user.last_name = last_name
            user.save()

            messages.info(request, "Información personal actualizada")
            return redirect(reverse_lazy('writer:profile'))
        except Exception as e:
            messages.error(request, "Tenemos un error al intentar guardar tu información. "
                                    "Por favor verifica que los campos estén completos")
            return redirect(reverse_lazy('writer:profile'))


class ProjectsDashboardView(LoginRequiredMixin, View):
    template_name = "writer/projects_dashboard.html"

    def get(self, request, *args, **kwargs):
        user = UserInformation.objects.get(user_id=request.user.id)
        qualified = Project.objects.filter(status=Project.QUALIFIED).count()
        send = Project.objects.filter(status=Project.SEND).count()
        for_correction = Project.objects.filter(
            Q(status=Project.FOR_CORRECTION) | Q(status=Project.DRAFT) | Q(status=Project.CREATED)
        ).count()
        in_correction = Project.objects.filter(status=Project.IN_CORRECTION).count()
        total_projects = Project.objects.filter(author_id=request.user.id).count()
        return render(request, self.template_name, {
            'user': user,
            'qualified': qualified,
            'send': send,
            'for_correction': for_correction,
            'in_correction': in_correction,
            'total_projects': total_projects,
        })


class ProjectsEditView(LoginRequiredMixin, View):
    template_name = "writer/project_edit.html"

    def get(self, request, *args, **kwargs):
        user = UserInformation.objects.get(user_id=request.user.id)
        project = Project.objects.get(id=kwargs.get('id'), author_id=request.user.id)
        categories_project = [{'id': cat.id, 'name': cat.name} for cat in project.category.only('id', 'name')]
        categories = Category.objects.all()
        return render(request, self.template_name, {
            'user': user,
            'project': project,
            'categories_project': categories_project,
            'categories': categories,
            'count_items': Question.objects.filter(
                project_id=kwargs.get('id'),
                project__author_id=request.user.id
            ).count()
        })

    def delete(self, request, *args, **kwargs):
        data = json.loads(request.body)
        query = Project.objects.get(
            id=data.get('id'),
            author_id=request.user.id
        )
        query.delete()
        return JsonResponse(
            status=200,
            data={
                'id': query.id,
                'message': 'Proyecto eliminado',
                'alert': 'info'
            }
        )


class ProjectQuestionsView(LoginRequiredMixin, View):

    def get(self, request, *args, **kwargs):
        query = Question.objects.filter(
            project_id=kwargs.get('id'),
            project__author_id=request.user.id
        ).only('id', 'title')
        questions = [{'id': q.id, 'title': q.title} for q in query]
        return JsonResponse(status=200, data={'questions': questions})


class ProjectDescriptionQuestionView(LoginRequiredMixin, View):

    def get(self, request, *args, **kwargs):
        query = Question.objects.get(
            id=kwargs.get('id'),
            project__author_id=request.user.id
        )
        return JsonResponse(status=200, data={'id': query.id, 'title': query.title, 'answer': query.answer})

    def delete(self, request, *args, **kwargs):
        data = json.loads(request.body)
        query = WriterController.delete_question(data, request)
        return JsonResponse(
            status=200,
            data={
                'id': query.id,
                'message': 'Item eliminado',
                'alert': 'info'
            }
        )

    def put(self, request, *args, **kwargs):
        data = json.loads(request.body)
        query = WriterController.update_questions(data, request)
        return JsonResponse(
            status=200,
            data={
                'item': {'id': query.id, 'title': query.title},
                'message': 'Item actualizado exitosamente'
            }
        )


class AddProjectView(LoginRequiredMixin, View):
    template_name = "writer/project_add.html"

    def get(self, request, *args, **kwargs):
        categories = Category.objects.all()
        return render(request, self.template_name, {'categories': categories})

    def post(self, request, *args, **kwargs):
        data = json.loads(request.body)
        categories = Category.objects.filter(id__in=data['categories']).only('id').values_list('id', flat=True)
        project = Project.objects.create(
            author=request.user,
            title=data['title'],
            description=data['description'],
            status=Project.CREATED,
            created_by=request.user.id
        )
        for c in categories:
            project.category.add(c)

        return JsonResponse(
            status=200,
            data={
                'id': project.id,
                'message': 'Proyecto creado exitosamente',
                'alert': 'success'
            }
        )

    def put(self, request, *args, **kwargs):
        data = json.loads(request.body)
        id_project = data.get('id_project', None)
        if not id_project:
            return JsonResponse(status=400, data={'message': 'Id proyecto no identificado', 'alert': 'warning'})

        message, alert, project_id = WriterController.update_project(id_project, data)

        return JsonResponse(
            status=200,
            data={
                'message': message,
                'alert': alert,
                'id': project_id
            }
        )


class AddQuestionsProjectView(LoginRequiredMixin, View):
    def post(self, request, *args, **kwargs):
        data = json.loads(request.body)
        id_project = data.get('id_project', None)
        if not id_project:
            return JsonResponse(
                status=400,
                data={
                    'message': 'Id proyecto no identificado',
                    'alert': 'warning'
                }
            )

        questions = list()
        for q in data.get('questions', None):
            if q.get('id', None):
                if q.get('delete') == 1:
                    query = WriterController.delete_question(q, request)
                else:
                    query = WriterController.update_questions(q, request)
            else:
                query = Question.objects.create(
                    title=q.get('title'),
                    answer=q.get('answer'),
                    project_id=id_project
                )
            questions.append({
                'id': query.id,
                'id_tmp': q.get('id_tmp'),
                'delete': q.get('delete'),
                'title': query.title,
                'answer': query.answer
            })
        return JsonResponse(
            status=200,
            data={
                'questions': questions,
                'message': 'Items creados exitosamente',
                'alert': 'success'
            }
        )

writer/templates/writer/add/step_1.html
<div class="step-content active" id="stepContent1" v-show="step==1">
    <div class="row">
        <div class="col-12">
            <h5 class="form-header">
                Datos básicos
            </h5>
            <div class="form-desc">
                En esta sección agrega los datos generales
                (importantes) de tu
                proyecto
            </div>
            <div class="form-group">
                <label for="title">Título</label>
                <input class="form-control" name="title" id="title" v-model="title"
                       placeholder="Agrega un título del proyecto"
                       type="text">
            </div>
            <div class="row">
                <div class="col-12">
                    <h5 class="form-header">
                        Descripción
                    </h5>
                    <div class="form-desc">
                        Agrega una descripción general del
                        proyecto
                    </div>
                    <textarea cols="80" name="description" v-model="description" id="ckeditor-main"
                              rows="10"></textarea>
                </div>
            </div>
            <br>
            <div class="form-group">
                <label for="categories"> Categoría</label>
                <select class="form-control select2" v-model="categories"
                        name="categories" id="categories"
                        multiple>
                    {% for c in categories %}
                        <option value="{{ c.id }}">
                            {{ c.name }}
                        </option>
                    {% endfor %}
                </select>
            </div>
            <div class="form-buttons-w text-right">
                <button class="btn btn-primary step-trigger-btn" :disabled="disableStepOne"
                        @click="createProject">Continuar
                </button>
            </div>
        </div>
    </div>
</div>

writer/templates/writer/add/step_2.html
<div class="step-content" id="stepContent2" v-show="step==2">
    <div class="row">
        <div class="col-sm-12">
            <h6 class="element-header">
                Items
            </h6>
            <div class="form-desc">
                En esta sección agrega cada uno de los items de
                los cuales se compone tu proyecto, pueden ser preguntas o secciones de
                contenido separadas por título y respuesta.
            </div>
            <div class="row">
                <div id="item-0"></div>
                <template v-for="item in questions">
                    <div class="col-md-12" :id="'item-'+item.id_tmp" v-show="item.delete==0">
                        <input type="hidden" :id="'id_tmp-'+item.id_tmp" :value="item.id_tmp">
                        <input type="hidden" :id="'id-'+item.id_tmp" v-model="item.id">
                        <div class="element-box bg-item">
                            <button class="close btn-delete-item" type="button" @click="removeItem(item.id_tmp)">
                                <span class="os-icon os-icon-close"></span>
                            </button>
                            <div class="form-group">
                                <label for="">Item #${item.id_tmp}</label>
                                <input class="form-control"
                                       :name="'title-'+item.id_tmp"
                                       :id="'title-'+item.id_tmp"
                                       placeholder="Agrega un título del proyecto"
                                       maxlength="255"
                                       type="text">
                            </div>
                            <div class="row">
                                <div class="col-sm-12">
                                    <h5 class="form-header">
                                        Respuesta
                                    </h5>
                                    <div class="form-desc">
                                        Agrega tu respuesta
                                    </div>
                                    <textarea cols="80"
                                              :id="'answer-'+item.id_tmp"
                                              :name="'answer-'+item.id_tmp"
                                              rows="5"></textarea>
                                </div>
                            </div>
                        </div>
                    </div>
                </template>
                <div class="col-md-12">
                    <div class="element-box add-item"
                         @click="addItem">
                        <i class="batch-icon-add"></i>
                        <span href="">Agregar un nuevo Item</span>
                    </div>
                </div>
            </div>
            <div class="form-buttons-w text-right">
                <button class="btn btn-secondary step-trigger-btn"
                        @click="changeStep(1)">Volver
                </button>
                <button @click="saveDraft(2)" class="btn btn-info step-trigger-btn">
                    Guardar borrador
                </button>
                <button class="btn btn-primary step-trigger-btn"
                        @click="saveQuestions();changeStep(3)">Continuar
                </button>
            </div>
        </div>
    </div>
</div>

writer/templates/writer/add/step_3.html
<div class="step-content" id="stepContent3" v-show="step==3">
    <div class="element-wrapper">
        <h5 class="form-header">
            Archivos adjuntos
        </h5>
        <div class="form-desc">
            En esta sección (si aplica), adjunta lo(s) archivo(s) de tu proyecto.
        </div>
        <form enctype="multipart/form-data" method="post"
              action="{% url 'projects:upload_files' %}"
              class="dropzone" id="my-awesome-dropzone">
            {% csrf_token %}
            <input type="hidden" name="id_project" v-model="id_project">
            <div class="dz-message">
                <div>
                    <h4>Adjunta tus archivos acá.</h4>
                    <div class="text-muted">
                        Arrastra y suelta tus archivos acá...
                        archivos permitidos .png, jpg, .pdf
                    </div>
                </div>
            </div>
        </form>
        <div class="form-buttons-w text-right">
            <button @click="saveDraft(3)"  class="btn btn-info step-trigger-btn">
                Guardar borrador
            </button>
            <button @click="changeStep(4)"  class="btn btn-primary step-trigger-btn">
                Continuar
            </button>
        </div>
    </div>
</div>